using UnityEngine;
using System.Collections;

public class Ball : MonoBehaviour {
	public float multiplier = 1.1f;
	public float minSpeed = 15;
	public float maxSpeed = 20;
	
	public float curSpeed = 0;
	
	public float wallHitTime;
	public float paddleHitTime;
	
	public BlockType ballColor = BlockType.Red;
	
	// Use this for initialization
	IEnumerator Start () {
		yield return new WaitForSeconds( 1.5f );
		
		rigidbody.AddRelativeForce( new Vector3( 0, -minSpeed, 0  ) );
		wallHitTime = Time.timeSinceLevelLoad;
		paddleHitTime = Time.timeSinceLevelLoad;
		//rigidbody.AddRelativeForce( new Vector3(minSpeed,0, 0  ) );
	}
	
	// Update is called once per frame
	void Update () {
		Debug.Log (Time.timeSinceLevelLoad - paddleHitTime);
	}
	
	void FixedUpdate() {
		curSpeed = Vector3.Magnitude(rigidbody.velocity);
		
		if (curSpeed > maxSpeed)
			rigidbody.velocity /= curSpeed / maxSpeed;
		
		if (curSpeed < minSpeed && curSpeed > 0)
			rigidbody.velocity /= curSpeed / minSpeed;
		
		//Debug.Log(rigidbody.velocity);
		if (Mathf.Abs(rigidbody.velocity.y) < 0.5 && curSpeed > 0)
		{
			if(rigidbody.velocity.y < 0)
				rigidbody.AddRelativeForce( new Vector3( 0, -5, 0  ) );
			if(rigidbody.velocity.y > 0)
				rigidbody.AddRelativeForce( new Vector3( 0, 5, 0  ) );
		}
		
		if(Time.timeSinceLevelLoad - paddleHitTime > 5)
		{
			if(Mathf.Abs(rigidbody.velocity.x) < 0.3)
			rigidbody.AddRelativeForce(new Vector3(5,0,0));
			//paddleHitTime = Time.timeSinceLevelLoad;
		}
	}
	
	void OnCollisionEnter( Collision col ) {
		if (col.gameObject.tag == "Player" || col.gameObject.tag == "wall" )
			wallHitTime = Time.timeSinceLevelLoad;
	}
}
