using UnityEngine;
using System.Collections;

public class Block : MonoBehaviour {
	public BlockType blockType = BlockType.Red;
	public GameObject blockPrefab;
	public GameObject colliderPrefab;
	private bool check = false;
	private bool sameColor = false;
	private bool destroy = false;
		
	private GameObject _ball;
	// Use this for initialization
	void Start () {
		MeshRenderer mr = GetComponent<MeshRenderer>();
		
		mr.material = Resources.Load( "Materials/block" + blockType.ToString() + " mat" ) as Material;
		_ball = GameObject.Find("ball");
		/*switch( blockType ) {
		case BlockType.Green:
				mr.material = Resources.Load("materials/blockGreen mat") as Material;
				break;
			
		case BlockType.Blue:
			mr.material = Resources.Load("materials/blockBlue mat") as Material;
			break;	
		
		}*/
		
	}
	
	void Update() {
	}
	
	IEnumerator OnCollisionEnter( Collision col ) {
		
		
		BlockType bt = _ball.GetComponent<Ball>().ballColor;
			
		float ballWallHitTime = _ball.GetComponent<Ball>().wallHitTime;
		//Debug.Log(Time.timeSinceLevelLoad - ballWallHitTime);
		if(Time.timeSinceLevelLoad - ballWallHitTime > 3)
		{
			Destroy(gameObject);
			yield break;
		}
		
		
		if(_ball.GetComponent<Ball>().ballColor == BlockType.Red)
				_ball.GetComponent<Ball>().ballColor = BlockType.Blue;
			else
				_ball.GetComponent<Ball>().ballColor = BlockType.Red;
		_ball.renderer.material = Resources.Load( "Materials/block" + _ball.GetComponent<Ball>().ballColor.ToString() + " mat" ) as Material;
		
		bool redBlocksExist = false;
			bool blueBlocksExist = false;
		
		foreach(GameObject block in GameObject.FindGameObjectsWithTag("block"))
			{				
				if(block.GetComponent<Block>().blockType == BlockType.Red)
					redBlocksExist = true;
				if(block.GetComponent<Block>().blockType == BlockType.Blue)
					blueBlocksExist = true;
			}
			
			if(!blueBlocksExist)
			{
				_ball.GetComponent<Ball>().ballColor = BlockType.Red;
				_ball.renderer.material = Resources.Load( "Materials/block" + _ball.GetComponent<Ball>().ballColor.ToString() + " mat" ) as Material;
			}
			if(!redBlocksExist)
			{
				_ball.GetComponent<Ball>().ballColor = BlockType.Blue;
				_ball.renderer.material = Resources.Load( "Materials/block" + _ball.GetComponent<Ball>().ballColor.ToString() + " mat" ) as Material;
			}
		
		
		Vector3 ballLocation = col.transform.position - transform.position;
		
			GameObject newBlock = null;
		GameObject collideChecker = null;
		
		if (ballLocation.x < -0.8)		
			collideChecker = (GameObject)Instantiate(colliderPrefab,new Vector3(transform.position.x - 1.4f,transform.position.y,
				transform.position.z), transform.rotation);
		else if(ballLocation.x > 0.8)
			collideChecker = (GameObject)Instantiate(colliderPrefab,new Vector3(transform.position.x + 1.4f,transform.position.y,
				transform.position.z), transform.rotation);
		
		else if(ballLocation.y > 0)
			collideChecker = (GameObject)Instantiate(colliderPrefab,new Vector3(transform.position.x, transform.position.y + 0.4f,
				transform.position.z), transform.rotation);
		
		else if(ballLocation.y < 0)
			collideChecker = (GameObject)Instantiate(colliderPrefab,new Vector3(transform.position.x,transform.position.y - 0.4f,
				transform.position.z), transform.rotation);
		
		yield return new WaitForSeconds( 0.3f );
		
	
		if(collideChecker.transform.position.y < -2)
		{
			Application.LoadLevel("GameOver");
			PlayerPrefs.SetInt("Score", Score.score);
		}
		
		
		if(collideChecker.tag == "free")		
			newBlock = (GameObject)Instantiate(blockPrefab,new Vector3(collideChecker.transform.position.x,collideChecker.transform.position.y,
				collideChecker.transform.position.z), transform.rotation);
				
		Destroy(collideChecker);
		
		
		
		if (newBlock != null)
		{
			newBlock.name = "block";
			newBlock.GetComponent<Block>().blockType = bt;		
			
			
			//Debug.Log (ballLocation.ToString());
			int neighbors = newBlock.GetComponent<Block>().SearchNeighbors() + 1;
			//Debug.Log(neighbors);
			
			foreach(GameObject block in GameObject.FindGameObjectsWithTag("block"))
			{
				if(neighbors > 2)
					if(block.GetComponent<Block>().sameColor == true)
						block.GetComponent<Block>().destroy = true;
				block.GetComponent<Block>().sameColor = false;
				block.GetComponent<Block>().check = false;
			}
			
			
			
			yield return new WaitForSeconds( 0.3f );
			
			foreach(GameObject block in GameObject.FindGameObjectsWithTag("block"))
			{
				if(block.GetComponent<Block>().destroy == true)
				{
					Destroy(block);
					Score.score += 10;
				}
			}
			
			 redBlocksExist = false;
			 blueBlocksExist = false;
		
			foreach(GameObject block in GameObject.FindGameObjectsWithTag("block"))
			{				
				if(block.GetComponent<Block>().blockType == BlockType.Red)
					redBlocksExist = true;
				if(block.GetComponent<Block>().blockType == BlockType.Blue)
					blueBlocksExist = true;
			}
			
			if(!blueBlocksExist)
			{
				_ball.GetComponent<Ball>().ballColor = BlockType.Red;
				_ball.renderer.material = Resources.Load( "Materials/block" + _ball.GetComponent<Ball>().ballColor.ToString() + " mat" ) as Material;
			}
			if(!redBlocksExist)
			{
				_ball.GetComponent<Ball>().ballColor = BlockType.Blue;
				_ball.renderer.material = Resources.Load( "Materials/block" + _ball.GetComponent<Ball>().ballColor.ToString() + " mat" ) as Material;
			}
				
			if (!blueBlocksExist && !redBlocksExist)
			{
				Application.LoadLevel("Victory");
				PlayerPrefs.SetInt("Score", Score.score);
			}
		
		}
	}
	
	public int SearchNeighbors()
	{
		check = true;
		sameColor = true;
		RaycastHit hit;
		int returnValue = 0;
        if (Physics.Raycast(transform.position, Vector3.right, out hit))
		{
			if (hit.transform.gameObject.name == "block" && hit.distance < 1 && hit.transform.gameObject.GetComponent<Block>().check == false)
			{								
				if(CheckColor(hit))
				{
					returnValue++;
					returnValue += hit.transform.gameObject.GetComponent<Block>().SearchNeighbors();					
				}
			}
		}
		 if (Physics.Raycast(transform.position, Vector3.left, out hit))
		{
			if (hit.transform.gameObject.name == "block" && hit.distance < 1 && hit.transform.gameObject.GetComponent<Block>().check == false)
			{								
				if(CheckColor(hit))
				{
					returnValue++;
					returnValue += hit.transform.gameObject.GetComponent<Block>().SearchNeighbors();					
				}
			}
		}
		 if (Physics.Raycast(transform.position, Vector3.up, out hit))
		{
			
			if (hit.transform.gameObject.name == "block" && hit.distance < 0.3f && hit.transform.gameObject.GetComponent<Block>().check == false)
			{								
				if(CheckColor(hit))
				{
					returnValue++;
					returnValue += hit.transform.gameObject.GetComponent<Block>().SearchNeighbors();					
				}
			}
		}
		 if (Physics.Raycast(transform.position, Vector3.down, out hit))
		{
			if (hit.transform.gameObject.name == "block" && hit.distance < 0.3f && hit.transform.gameObject.GetComponent<Block>().check == false)
			{								
				if(CheckColor(hit))
				{
					returnValue++;
					returnValue += hit.transform.gameObject.GetComponent<Block>().SearchNeighbors();					
				}
			}
		}
		return returnValue;
		
	}
	
	public bool CheckColor(RaycastHit hit)
	{
		hit.transform.gameObject.GetComponent<Block>().check = true;
				if(hit.transform.gameObject.GetComponent<Block>().blockType == blockType)
				{
					hit.transform.gameObject.GetComponent<Block>().sameColor = true;
					return true;
				}
				else
					return false;
	}
}


	


public enum BlockType {
	Red = 10,
	Green = 25,
	Blue = 50
}