/// <summary>
/// Player.cs
/// Date
/// Author
/// 
/// Get the player input
/// move paddle accordingly along the x axis 
/// make sure the paddle is always at 0 on the z axis
/// make sure the paddle is always at the same position on y axis
/// create side boundries the player can not move by
/// 
/// </summary> 

using UnityEngine;
using System.Collections;

public class Player : MonoBehaviour {
	public static float zPosition = 0;
	public float yPosition = 0;
	public float xBoundry = 0;
	public float speed = 5;
	
	private Transform _t;
	private GameObject _ball;
	
	// Use this for initialization
	void Start () {
		_t = transform;
		
		_t.position = new Vector3( 0, yPosition, zPosition );
		_ball = GameObject.Find("ball");
	}
	
	// Update is called once per frame
	void Update () {
		//get player input
		if( Input.GetAxis( "Horizontal" ) != 0 ) {
			//move paddle according to input along the x-axis
			_t.position = new Vector3( _t.position.x + Input.GetAxisRaw( "Horizontal" ) * speed * Time.deltaTime ,yPosition , zPosition );
			
			//check boundries
			if( _t.position.x < -xBoundry + 1.5f )
					_t.position = new Vector3( -xBoundry + 1.5f ,yPosition , zPosition );
			else if( _t.position.x > xBoundry - 1.5f )
					_t.position = new Vector3( xBoundry - 1.5f ,yPosition , zPosition );
			
			
		}
		
		
			bool redBlocksExist = false;
			bool blueBlocksExist = false;
		
			foreach(GameObject block in GameObject.FindGameObjectsWithTag("block"))
			{				
				if(block.GetComponent<Block>().blockType == BlockType.Red)
					redBlocksExist = true;
				if(block.GetComponent<Block>().blockType == BlockType.Blue)
					blueBlocksExist = true;
			}
			
			
				
			if (!blueBlocksExist && !redBlocksExist)
			{
				Application.LoadLevel("Victory");
				PlayerPrefs.SetInt("Score", Score.score);
			}	
	}
	
	void OnCollisionEnter( Collision col ) {
		//Debug.Log("hit paddle");
		//Debug.Log("First point that collided: " + (col.contacts[0].point - transform.position));
		_ball.rigidbody.velocity = new Vector3((col.contacts[0].point - transform.position).x * 
			Mathf.Abs((col.contacts[0].point - transform.position).x) * 4,
			_ball.rigidbody.velocity.y,_ball.rigidbody.velocity.z);
		//rigidbody.velocity += rigidbody.velocity * multiplier;
		_ball.GetComponent<Ball>().paddleHitTime = Time.timeSinceLevelLoad;
	
	}
}
